rawset(_G, "ConklersInitTable", function(p)
	CONS_Printf(p,"\x86"+"Initializing Conklers's table...")
	
	//conklers stuff
	
	p.conklerstable = {
	form = 0,
	transform = 0,
	pallette = 1,
	blood = 1,
	health = 8,
	transformban = 0
	}
	
	
	CONS_Printf(p,"\x85"+"Conkler's Variables Have Been Validated!")
	CONS_Printf(p,"\x83"+"Made by Banddy (Or Bandder on the MB)")
	return true
end)

rawset(_G, "HurryUpChars",{ 
	"Conklers",
	"Sonki"
	}
)

//modifiers
rawset(_G, "HurryUpOff", 0)
rawset(_G, "Deeznuts", 0)
rawset(_G, "Resource", 0)
rawset(_G, "Lap2", 0)
rawset(_G, "OneLife", 0)


addHook("MobjDeath", function (mo)
    if CONK_ITEM_DROPS[mo.type] ~= nil then
        local item = P_SpawnMobjFromMobj(mo, 0, 0, 40*FU, CONK_ITEM_DROPS[mo.type])
        item.momz = P_MobjFlip(mo)*FU*5
		item.momx = P_MobjFlip(mo)*FU*10
        -- somethin with the type from ITEM_DROP[mo.type]
    end
end)

/*
rawset(_G, "AddSkipMonitor", function(mobjtype, cost, passive, active)
    skiptotalcraft = $+1
    skipcraftlist[skiptotalcraft] = mobjtype
    skipcost[mobjtype] = cost
    skippassive[mobjtype] = passive
    skipactive[mobjtype] = active
    return id
end)
*/

//made by clairbun so that srb2 can do basic shit...
rawset(_G, "L_Choose", function(...)
	local args = {...}
	local choice = P_RandomRange(1,#args)
	return args[choice]
end)



addHook("PlayerThink",function(p)
if (p.conklerstable == nil) then
  ConklersInitTable(p)
end
end)

rawset(_G, "CONK_SKIN", "conklers")

local formnumber = {
	"GUN",
	"FIRE",
	"SWORD",
	"ELEC",
	"SPIKE",
	"",
	"CLOUD"
}
for k,v in ipairs(formnumber)
	rawset(_G,"FORM_"..v,1<<(k-1))
	print("Enummed FORM_"..v.." ("..1<<(k-1)..")")
end

//sounds
freeslot("sfx_cnat","sfx_gpim","sfx_gpod","sfx_pish","sfx_pigb")
sfxinfo[sfx_gpim].caption = "ConkPound"
sfxinfo[sfx_gpod].caption = "ConkPound Start"
sfxinfo[sfx_cnat].caption = "Dash Start"
sfxinfo[sfx_pish].caption = "Gun Shoot"
sfxinfo[sfx_pigb].caption = '\x82"Undertale Yellow"\x80'

freeslot("S_CONK_GRAVE","SPR2_GRAY")
states[S_CONK_GRAVE] = {
    sprite = SPR_PLAY,
    frame = SPR2_GRAY,
    tics = -1,
}
freeslot("S_PLAY_GPOUND","S_PLAY_GPOUNDWAIT")

states[S_PLAY_GPOUND] = {
    sprite = SPR_PLAY,
    frame = SPR2_LAND,
    nextstate = S_PLAY_GPOUND
}

states[S_PLAY_GPOUNDWAIT] = {
    sprite = SPR_PLAY,
    frame = SPR2_LAND,
    tics = 6,
    nextstate = S_PLAY_GPOUNDWAIT
}

freeslot("SPR_COBL","S_CONKBOOLET","MT_CONKBOOLET")

states[S_CONKBOOLET] = {
    sprite = SPR_COBL,
    frame = A,
    tics = -1,
    nextstate = S_NULL
}

mobjinfo[MT_CONKBOOLET] = {
	doomednum = -1,
	spawnstate = S_CONKBOOLET,
	spawnhealth = 1,
	seestate = S_CONKBOOLET,
	seesound = sfx_pish,
	deathstate = S_SMOKE1,
	deathsound = sfx_corkh,
	speed = 60*FRACUNIT,
	radius = 10*FRACUNIT,
	height = 10*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY
	}
	
freeslot("SPR_CGUN","S_CONKPISTOL","MT_CONKPISTOL","SPR_COCS","S_CONK_SHOOT1","S_CONK_SHOOT2","S_CONK_SHOOT3")

states[S_CONKPISTOL] = {
    sprite = SPR_CGUN,
    frame = A|FF_ANIMATE,
    tics = -1,
	var1 = 3,
	var2 = 4,
    nextstate = S_NULL
}

mobjinfo[MT_CONKPISTOL] = {
	doomednum = 6736,
	spawnstate = S_CONKPISTOL,
	spawnhealth = 1,
	seestate = S_CONKPISTOL,
	seesound = nil,
	deathstate = S_SMOKE1,
	deathsound = nil,
	speed = 60*FRACUNIT,
	radius = 30*FRACUNIT,
	height = 30*FRACUNIT,
	flags = MF_SLIDEME|MF_SPECIAL
	}
	
states[S_CONK_SHOOT1] = {
	sprite = SPR_COCS,
	frame = A,
	tics = 3,
	nextstate = S_CONK_SHOOT2
}

states[S_CONK_SHOOT2] = {
	sprite = SPR_COCS,
	frame = B,
	tics = 3,
	nextstate = S_CONK_SHOOT3
}

states[S_CONK_SHOOT3] = {
	sprite = SPR_COCS,
	frame = C,
	tics = 5,
	nextstate = S_PLAY_WALK
}



//skincolor

freeslot("SKINCOLOR_WERIO")
skincolors[SKINCOLOR_WERIO] = {
	name = "Werio",
	ramp = {200,32,34,36,38,40,207,186,186,187,187,187,187,187,187,46},
	invcolor = SKINCOLOR_SEAFOAM,
	invshade = 7,
	chatcolor = V_REDMAP,
	accessible = true
}

freeslot("SKINCOLOR_ALTWERIO")
skincolors[SKINCOLOR_ALTWERIO] = {
	name = "AltWerio",
	ramp = {34,34,34,34,34,34,204,204,203,203,204,184,185,185,186,169},
	invcolor = SKINCOLOR_SAPPHIRE,
	invshade = 7,
	chatcolor = V_REDMAP,
	accessible = true
}

freeslot("SKINCOLOR_TOTEMPURPLE")
skincolors[SKINCOLOR_TOTEMPURPLE] = {
	name = "TotemPurple",
	ramp = {160,161,162,162,163,164,164,165,166,153,154,155,156,157,158,253},
	invcolor = SKINCOLOR_SALMON,
	invshade = 6,
	chatcolor = V_PURPLEMAP,
	accessible = true
}

freeslot("SKINCOLOR_NEONGWEEN")
skincolors[SKINCOLOR_NEONGWEEN] = {
	name = "NeonGween",
	ramp = {88,89,96,96,97,97,112,112,113,113,114,115,115,116,117,118},
	invcolor = SKINCOLOR_RED,
	invshade = 7,
	chatcolor = V_PERIDOTMAP,
	accessible = true
}

freeslot("SKINCOLOR_THOKKER")
skincolors[SKINCOLOR_THOKKER] = {
	name = "Thokker",
	ramp = {121,140,140,141,135,149,150,151,153,154,155,156,157,158,253,254},
	invcolor = SKINCOLOR_BRONZE,
	invshade = 5,
	chatcolor = V_BLUEMAP,
	accessible = true
}

//afterimagescolors
freeslot("SKINCOLOR_CONKLERSAIVLOO")
skincolors[SKINCOLOR_CONKLERSAIVLOO] = {
	name = "ConklersAIVloo",
	ramp = {128,129,130,133,135,135,135,136,136,136,155,156,157,158,253,31},
	invcolor = SKINCOLOR_ORANGE,
	invshade = 8,
	chatcolor = V_BLUEMAP,
	accessible = true
}

freeslot("SKINCOLOR_CONKLERSAIVREEN")
skincolors[SKINCOLOR_CONKLERSAIVREEN] = {
	name = "ConklersAIVreen",
	ramp = {96,97,97,98,112,112,113,113,114,125,125,125,125,126,139,31},
	invcolor = SKINCOLOR_RED,
	invshade = 8,
	chatcolor = V_GREENMAP,
	accessible = true
}

freeslot("SKINCOLOR_CONKLERSAIGED")
skincolors[SKINCOLOR_CONKLERSAIGED] = {
	name = "ConklersAIGed",
	ramp = {209,210,210,32,33,34,34,35,36,38,39,41,42,44,47,31},
	invcolor = SKINCOLOR_GREEN,
	invshade = 8,
	chatcolor = V_REDMAP,
	accessible = true
}

freeslot("SKINCOLOR_CONKLERSAIERANGE")
skincolors[SKINCOLOR_CONKLERSAIERANGE] = {
	name = "ConklersAIErange",
	ramp = {48,216,49,50,64,51,52,53,53,55,67,68,68,79,239,31},
	invcolor = SKINCOLOR_BLUEBELL,
	invshade = 8,
	chatcolor = V_ORANGEMAP,
	accessible = true
}

freeslot("SKINCOLOR_CONKLERSAIJELLOW")
skincolors[SKINCOLOR_CONKLERSAIJELLOW] = {
	name = "ConklersAIJellow",
	ramp = {80,81,82,83,72,72,73,73,74,74,75,76,77,78,238,31},
	invcolor = SKINCOLOR_BLUEBELL,
	invshade = 8,
	chatcolor = V_YELLOWMAP,
	accessible = true
}

freeslot("SKINCOLOR_CONKLERSAILURPLE")
skincolors[SKINCOLOR_CONKLERSAILURPLE] = {
	name = "ConklersAILurple",
	ramp = {176,160,161,162,162,163,163,164,164,165,166,167,167,168,253,31},
	invcolor = SKINCOLOR_YELLOW,
	invshade = 8,
	chatcolor = V_PURPLEMAP,
	accessible = true
}

freeslot("SKINCOLOR_CONKLERSAIWHITE")
skincolors[SKINCOLOR_CONKLERSAIWHITE] = {
	name = "ConklersAIWhite",
	ramp = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	invcolor = SKINCOLOR_BLACK,
	invshade = 6,
	chatcolor = V_GRAYMAP,
	accessible = true
}

freeslot("SKINCOLOR_CONKLERSAIPANK")
skincolors[SKINCOLOR_CONKLERSAIPANK] = {
	name = "ConklersAIPank",
	ramp = {180,180,202,202,202,202,202,202,202,192,192,178,178,178,178,178},
	invcolor = SKINCOLOR_BLACK,
	invshade = 6,
	chatcolor = V_MAGENTAMAP,
	accessible = true
}

freeslot("SKINCOLOR_CONKLERSAIBRAUN")
skincolors[SKINCOLOR_CONKLERSAIBRAUN] = {
	name = "ConklersAIBraun",
	ramp = {67,67,67,67,67,67,67,67,67,67,67,67,67,67,67,67},
	invcolor = SKINCOLOR_BLACK,
	invshade = 6,
	chatcolor = V_BROWNMAP,
	accessible = true
}

freeslot("SKINCOLOR_CAIANTONLIME")
skincolors[SKINCOLOR_CAIANTONLIME] = {
	name = "CAIAntonLime",
	ramp = {188,188,188,188,188,188,188,188,188,188,188,188,188,188,188,188},
	invcolor = SKINCOLOR_SKY,
	invshade = 9,
	chatcolor = V_PERIDOTMAP,
	accessible = true
}

freeslot("SKINCOLOR_CAIANTONBLUE")
skincolors[SKINCOLOR_CAIANTONBLUE] = {
	name = "CAIAntonBlue",
	ramp = {137,137,137,137,137,137,137,137,137,137,137,137,137,137,137,137},
	invcolor = SKINCOLOR_SKY,
	invshade = 9,
	chatcolor = V_BLUEMAP,
	accessible = true
}

freeslot("SKINCOLOR_CAIANTONRED")
skincolors[SKINCOLOR_CAIANTONRED] = {
	name = "CAIAntonRED",
	ramp = {35,35,35,35,35,35,35,35,35,35,35,35,35,35,35,35},
	invcolor = SKINCOLOR_SKY,
	invshade = 9,
	chatcolor = V_REDMAP,
	accessible = true
}


//objects
freeslot("MT_DKHAMMER","S_DKHAMMER","SPR_HMMR")
mobjinfo[MT_DKHAMMER] = {
	doomednum = 3783,
	spawnstate = S_DKHAMMER,
	spawnhealth = 1000,
	speed = 0,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	mass = 100,
	flags = MF_SOLID,
}
states[S_DKHAMMER] = {
	sprite = SPR_HMMR,
	frame = A,
	tics = 35,
	action = A_Look,
	nextstate = S_DKHAMMER
}

freeslot("SKINCOLOR_FIRETRANSFO")
skincolors[SKINCOLOR_FIRETRANSFO] = {
	name = "FireTransfo",
	ramp = {35,35,55,54,54,53,74,73,73,74,53,54,54,55,35,35},
	invcolor = SKINCOLOR_RED,
	invshade = 6,
	chatcolor = V_YELLOWMAP,
	accessible = true
}

//these are the only two lines you need to edit!
local flashColor = skincolors[SKINCOLOR_FIRETRANSFO] //change this to your desired skincolor!
local flashDelay = 3  //change this to how many tics it takes to animate

local rampPos = 1
local rampDir = true
local ramps = {}

//convert the ramp to a table
ramps[1] = {}
for i = 0, 15, 1
	ramps[1][i+1] = flashColor.ramp[i]
end

//create the offset versions of the ramp
for i = 2, 16,1
	ramps[i] = {}

	for pos,val in ipairs(ramps[i-1]) do
		if not (pos == 16) then
			ramps[i][pos+1] = val
		else
			ramps[i][1] = val
		end
	end
end

local function RampChange()
	if (rampDir) then
		rampPos = $1+1
	else
		rampPos = $1-1
	end
end

local function RampLoop()
	if not (leveltime % flashDelay) then

		RampChange()
		
		//position is too high/low, reverse your direction
		if not (ramps[rampPos])
			rampDir = not rampDir
			RampChange()
		end

		flashColor.ramp = ramps[rampPos]
	end
end

addHook("ThinkFrame", RampLoop)
