freeslot("MT_FROG_BOX","SPR_FBOX","MT_FROG_ICON","S_FROG_BOX","S_FROG_ICON1","S_FROG_ICON2")

mobjinfo[MT_FROG_BOX] = {
	--$Name Frog Switch Box
	--$Sprite FBOXA0
	--$Category Monitors
	doomednum = 6735,
	spawnstate = S_FROG_BOX,
	reactiontime = 8,
	painstate = S_FROG_BOX,
	deathstate = S_BOX_POP1,
	deathsound = sfx_pop,
	speed = 1,
	radius = 18*FRACUNIT,
	height = 40*FRACUNIT,
	mass = 100,
	damage = MT_FROG_ICON,
	flags = MF_SOLID|MF_SHOOTABLE|MF_MONITOR
}

mobjinfo[MT_FROG_ICON] = {
	doomednum = -1,
	spawnstate = S_FROG_ICON1,
	seesound = sfx_kc54,
	reactiontime = 8,
	deathsound = sfx_pop,
	speed = 2*FRACUNIT,
	radius = 8*FRACUNIT,
	height = 14*FRACUNIT,
	mass = 100,
	damage = 62*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_BOXICON|MF_SCENERY
}

states[S_FROG_BOX] = {SPR_FBOX,A,2,nil,0,0,S_BOX_FLICKER}
states[S_FROG_ICON1] = {SPR_FBOX,C|FF_ANIMATE,18,nil,3,4,S_FROG_ICON2}
states[S_FROG_ICON2] = {SPR_FBOX,C,18,nil,nil}

local FROGMONITOR_MAP = {
  [MT_FROG_BOX] = MT_FROGSWITCH,
}

addHook("PlayerSpawn", function(p)
if skipinit == 0
 AddSkipMonitor(MT_FROG_BOX, 30, "\x83 Active:\x80 Spawns Frog Switch For Conklers", "\x84 Passive:\x80 Could Be Used As A Platform Maybe")
 skipinit = 1
 end
 end)
 
 addHook("PlayerSpawn", function(p)
 if skipinit == nil
 skipinit = 0
 end
 end)

addHook("MobjDeath", function (mo)
    if FROGMONITOR_MAP[mo.type] ~= nil then
        local frog = P_SpawnMobjFromMobj(mo, 0, 0, 40*FU, FROGMONITOR_MAP[mo.type])
        frog.momz = P_MobjFlip(mo)*FU*5
		frog.momx = P_MobjFlip(mo)*FU*20
		frog.scale = $*2
        -- somethin with the type from PUNCHBALL_MONITOR_MAP[mo.type]
    end
end)