addHook("PlayerThink", function(p)
if not srb2p return end
	if p.charging == nil
		p.charging = false
	end
end)

addHook("AbilitySpecial", function(p)
if not srb2p return end
	if p.mo.skin == CONK_SKIN
		and (p.mo.state == S_PLAY_JUMP)
		and not (p.powers[pw_shield])
		and not (p.mo.state == S_PLAY_PAIN)
		and not (p.mo.state == S_PLAY_DEAD)
		and not (p.mo.state == S_PLAY_DRWN)
		p.charging = true
		S_StartSound(p.mo, sfx_drpdsh)
		p.mo.state = S_PLAY_ROLL
	end	
end)


addHook("PlayerThink", function(p)
if not srb2p return end
	if p.charging
	and not (p.cmd.buttons & BT_JUMP)
	or p.charging
	and P_CheckDeathPitCollide(p.mo, true)
		p.charging = false
		p.mo.state = S_PLAY_JUMP
	end
end)


addHook("PlayerThink", function(p)
if not srb2p return end
	if p.mo.skin == CONK_SKIN
		and p.charging
		and not P_CheckDeathPitCollide(p.mo, true)
		and (P_IsObjectOnGround(p.mo) or (p.mo.eflags & MFE_JUSTHITFLOOR))
		   S_StartSound(p.mo, sfx_zoom)
		   p.mo.state = S_PLAY_DASH
		   p.charging = false
		   P_InstaThrust(p.mo, p.mo.angle, 10*FRACUNIT+p.speed)
		   P_SpawnSkidDust(p, 13*FRACUNIT, sfx_none)
		   P_SpawnSkidDust(p, 13*FRACUNIT, sfx_none)
		   P_SpawnSkidDust(p, 13*FRACUNIT, sfx_none)
	    end
     	   if p.charging
	       and (p.powers[pw_justsprung] or p.mo.eflags & MFE_SPRUNG)
		   p.charging = false
	    end
end)


addHook("PlayerThink", function(p)
if not srb2p return end
		if p.mo.skin == CONK_SKIN
	and (p.pflags & PF_SPINNING)
	and (p.pflags & PF_JUMPED)
		p.pflags = $ & ~PF_SPINNING
	end
end)