/*freeslot("SPR_SLIM","SPR_SSIM","S_CONK_SLIMEWALK1","S_CONK_SLIMEJUMP1","S_CONK_SLIMEWALK2","S_CONK_SLIMEJUMP2")
states[S_CONK_SLIMEWALK1] = {
	sprite = SPR_SLIM,
	frame = A,
	tics = 3,
	nextstate = S_CONK_SLIMEWALK2
}
states[S_CONK_SLIMEWALK2] = {
	sprite = SPR_SLIM,
	frame = B,
	tics = 3,
	nextstate = S_CONK_SLIMEWALK1
}
states[S_CONK_SLIMEJUMP1] = {
	sprite = SPR_SSIM,
	frame = A,
	tics = 3,
	nextstate = S_CONK_SLIMEJUMP2
}
states[S_CONK_SLIMEJUMP2] = {
	sprite = SPR_SSIM,
	frame = B,
	tics = 3,
	nextstate = S_CONK_SLIMEJUMP1
}

freeslot("SPR2_FYRE","S_CONK_FIRE")
states[S_CONK_FIRE] = {
    sprite = SPR_PLAY,
    frame = SPR2_FYRE,
    tics = -1,
}
*/

local gunned = 0
local gunkills = 0
local fps = 0

COM_AddCommand("bloodtoggle", function(p)
if p.conklerstable.blood == 1
p.conklerstable.blood = 0
else
p.conklerstable.blood = 1
end
end)

COM_AddCommand("fps", function(p)
fps = 1
end)

freeslot("SPR_BLUD", "S_GUNBLOOD", "MT_GUNBLOOD", "S_GUNBLOODSPLAT")
mobjinfo[MT_GUNBLOOD] = {
	flags = MF_SCENERY|MF_STICKY,
	spawnstate = S_GUNBLOOD,
	spawnhealth = 10000,
	radius = 1*FRACUNIT,
	height = 1*FRACUNIT
}

states[S_GUNBLOOD] = {
	sprite = SPR_BLUD,
	frame = A,
	tics = -1,
	nextstate = S_GUNBLOOD
}

states[S_GUNBLOODSPLAT] = {
	sprite = SPR_BLUD,
	frame = B,
	tics = -1,
	nextstate = S_GUNBLOOD
}

addHook("PlayerThink", function(p)
if srb2p return end
		if p.mo.skin == CONK_SKIN
		and p.conklerstable.form & FORM_GUN
		gunned = 1
		else
		gunned = 0
	end
end)


COM_AddCommand("transformgun", function(p)
p.conklerstable.form = FORM_GUN
S_StartSound(p.mo,sfx_pigb)
end)


addHook("PlayerThink", function(p)
if srb2p return end
	local me = p.realmo
		if me.skin == CONK_SKIN
		and p.conklerstable.form & FORM_GUN
		and p.conklerstable.transformban == 0
		p.conklerstable.transform = 1
		p.mo.color = SKINCOLOR_YELLOW
	end
end)

addHook("PlayerThink", function(p)
if srb2p return end
	if p.mo.buttonholding == nil
		p.mo.buttonholding = false
	end
	if not (p.cmd.buttons & BT_USE or p.cmd.buttons & BT_CUSTOM1 or p.cmd.buttons & BT_ATTACK) 
	p.mo.buttonholding = false
	end
	local me = p.realmo
		if me.skin == CONK_SKIN
		and p.conklerstable.form & FORM_GUN
		and p.conklerstable.transformban == 0
		and (p.cmd.buttons & BT_USE or p.cmd.buttons & BT_CUSTOM1 or p.cmd.buttons & BT_ATTACK)
		and not p.mo.buttonholding
		p.mo.buttonholding = true
		p.mo.state = S_CONK_SHOOT1
		if fps == 0
		P_SPMAngle(p.mo,MT_CONKBOOLET,p.mo.angle,0)
		else
			bullet = P_SpawnPointMissile(
				mo,
				mo.x + P_ReturnThrustX(nil, mo.angle, FRACUNIT),
				mo.y + P_ReturnThrustY(nil, mo.angle, FRACUNIT),
				p.viewz + (sin(player.aiming)*90),
				MT_CONKBOOLET,
				mo.x, mo.y, p.viewz
			)
		end
		if P_IsObjectOnGround(p.mo)
		P_SetObjectMomZ(p.mo, 2*FRACUNIT)
		end
	end
end)

local function Blood(mo)
	local blood = P_SpawnMobjFromMobj(mo, 0, 0, mo.height/2, MT_GUNBLOOD)
		local angle = P_RandomRange(-10, 10)*ANG1/2
		blood.momx = P_MobjFlip(mo)*FU*(P_RandomRange(-10, 10))
		blood.momy = P_MobjFlip(mo)*FU*(P_RandomRange(-10, 10))
		blood.momz = P_MobjFlip(mo)*FU*(P_RandomRange(-10, 10))
	blood.blood_sizeto = P_RandomRange(FU/2, FU)
end

addHook("MobjDeath",function(mo,inf,source)
	if not source
	or not source.valid
	return end
	if source
	and source.skin == CONK_SKIN
	and source.player
	and source.player.valid
	if (mo.flags & MF_ENEMY or mo.flags & MF_BOSS)
	and gunned == 1
	and source.player.conklerstable.blood == 1
		gunkills = $+1
		Blood(mo)
		Blood(mo)
		Blood(mo)
		Blood(mo)
		Blood(mo)
		Blood(mo)
		Blood(mo)
		Blood(mo)
		Blood(mo)
		Blood(mo)
		Blood(mo)
		Blood(mo)
		Blood(mo)
		Blood(mo)
	end
	end
end)

addHook("MobjDamage",function(mo,inf,source)
	if not source
	or not source.valid
	return end
	if source
	and source.skin == CONK_SKIN
	and source.player
	and source.player.valid
	if (mo.flags & MF_ENEMY or mo.flags & MF_BOSS)
	and gunned == 1
	and source.player.conklerstable.blood == 1
	and source.player.conklerstable.transformban == 0
		Blood(mo)
	end
	end
end)

addHook("MobjThinker",function(mo)
	if P_IsObjectOnGround(mo)
		mo.renderflags = $ | (RF_SPLATMASK | RF_SPRITETYPEMASK | RF_FLOORSPRITE | RF_SLOPESPLAT)
		mo.state = S_GUNBLOODSPLAT
		mo.momx = 0
		mo.momy = 0
		
		if mo.blood_animtics == nil then
			mo.blood_animtics = 0
		end
		
		if  mo.blood_animtics ~= nil and mo.blood_animtics < 35 then
			local ese = ease.outcubic(FixedDiv(mo.blood_animtics*FU, 35*FU), mo.blood_sizeto)
			mo.blood_animtics = $ + 1
			
			mo.spritexscale = ese
			mo.spriteyscale = ese
		end
	else
		mo.state = S_GUNBLOOD
	end
end,MT_GUNBLOOD)

local function ringstring(v, p)
if srb2p return end
	local me = p.mo
	if me.skin == CONK_SKIN and p.mo and p.mo.valid and p.conklerstable.form & FORM_GUN and p.conklerstable.transformban == 0 then
	v.drawString(10, 140, "Kills: " ..gunkills.. "", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_REDMAP, "left")
    end
end
hud.add(ringstring, "game")


local function GunCollect(mo,mobj) 
if srb2p return end
	if displayplayer.valid
	and displayplayer.mo and displayplayer.mo.valid
	and displayplayer.mo.skin == "conklers"
	and displayplayer.conklerstable.transformban == 0
	S_StartSound(mo,sfx_pigb)
	displayplayer.conklerstable.form = FORM_GUN
	end
end

addHook("MobjDeath",GunCollect,MT_CONKPISTOL)

addHook("PlayerMsg", function(p, type, _, msg)
	if type ~= 0
	or p.mo.skin ~= CONK_SKIN
	or p.panim ~= PA_IDLE
	or p.conklerstable.transformban == 1
	or p.conklerstable.form & FORM_GUN  return end
	
	if string.lower(msg) == "gimmie a gun"
		displayplayer.conklerstable.form = FORM_GUN
		S_StartSound(mo,sfx_pigb)
		return true
	end
end)

