rawset(_G, "CONK_MENU",{})
local tm = CONK_MENU

tm.entries = {
	--increase this [0] by 1 for each page
	[0] = {
		title = "Conklers Help",
		--special string colors (like this one)
		--or a SKINCOLOR_* const
		color = "p.skincolor",
		--the text thatll youll scroll through
		text = {
			"Menu Help",
			"Close Menu",
		},
		--the commands that will be executed
		commands = {
			"showconkmenuhints",
			"openconkmenu",
		},
		--the text at the bottom
		hints = {
			"Show the controls.",
			"",
		}
	},
	[1] = {
		title = "Conklers Settings",
		--special string colors (like this one)
		--or a SKINCOLOR_* const
		color = SKINCOLOR_ISLAND,
		--the text thatll youll scroll through
		text = {
			"Blood Toggle - ".."p.conklerstable.blood".."",
			"Transformation Bans - ".."\x86".."NOT RECCOMENDED",
		},
		--the commands that will be executed
		commands = {
			"bloodtoggle",
			"bantransformations",
		},
		--the text at the bottom
		hints = {
			"Toggle blood effects for the gun transformation.",
			"Ban Transformations entirely so you only play like Wario ig",
		}
	},
	[2] = {
		title = "Hurry Up Settings",
		--special string colors (like this one)
		--or a SKINCOLOR_* const
		color = SKINCOLOR_ROSY,
		--the text thatll youll scroll through
		text = {
			"Toggle Hurry Up",
			"Default Hurry Up Music Toggle",
			"deeznuts modifier toggle - "..Deeznuts.."",
		},
		--the commands that will be executed
		commands = {
			"hurryuptoggle",
			"hurryupmusictoggle",
			"deeznutsmod",
		},
		--the text at the bottom
		hints = {
			"Turns Hurry Up On/Off",
			"Toggles the escape theme between Conklers's escape theme (composed by Chrissy CILC) or 'Hurry Up' from Wario Land 4",
			"Toggles the pizza face ripoff known as 'Deeznuts'",
		}
	},
	[3] = {
		title = "Conklers Debug",
		--special string colors (like this one)
		--or a SKINCOLOR_* const
		color = SKINCOLOR_PURPLE,
		--the text thatll youll scroll through
		text = {
			"Give Cloud Transformation",
			"Give Fire Transformation",
			"Give Gun Transformation",
		},
		--the commands that will be executed
		commands = {
			"transformcloud",
			"transformfire",
			"transformgun",
		},
		--the text at the bottom
		hints = {
			"Makes Conklers floaty like a cloud!",
			"Gives Conklers firey abilities!",
			"For his neutral special, he weilds a GUN",
		}
	},
}

COM_AddCommand("showconkmenuhints", function(p)
	local menu = p.conk_menu
	
	if not menu
		return
	end
	
	if not menu.menuinaction
		return
	end
	
	if menu.hintfade
		return
	end
	
	menu.hintfade = 3*TR+18
end)

COM_AddCommand("openconkmenu", function(p)
	ConkMenuOpenClose(p)
end)

