/*freeslot("SPR_SLIM","SPR_SSIM","S_CONK_SLIMEWALK1","S_CONK_SLIMEJUMP1","S_CONK_SLIMEWALK2","S_CONK_SLIMEJUMP2")
states[S_CONK_SLIMEWALK1] = {
	sprite = SPR_SLIM,
	frame = A,
	tics = 3,
	nextstate = S_CONK_SLIMEWALK2
}
states[S_CONK_SLIMEWALK2] = {
	sprite = SPR_SLIM,
	frame = B,
	tics = 3,
	nextstate = S_CONK_SLIMEWALK1
}
states[S_CONK_SLIMEJUMP1] = {
	sprite = SPR_SSIM,
	frame = A,
	tics = 3,
	nextstate = S_CONK_SLIMEJUMP2
}
states[S_CONK_SLIMEJUMP2] = {
	sprite = SPR_SSIM,
	frame = B,
	tics = 3,
	nextstate = S_CONK_SLIMEJUMP1
}

freeslot("SPR2_FYRE","S_CONK_FIRE")
states[S_CONK_FIRE] = {
    sprite = SPR_PLAY,
    frame = SPR2_FYRE,
    tics = -1,
}
*/

COM_AddCommand("transformcloud", function(p)
p.conklerstable.form = FORM_CLOUD
end)

addHook("PlayerThink", function(p)
if srb2p return end
local me = p.realmo
	if p.mo and p.mo.valid
	if me.skin == CONK_SKIN
	and p.conklerstable.form & FORM_CLOUD
	and not (p.mo.flags & MF_NOGRAVITY)
	and not (p.mo.flags & MF_NOTHINK)
	and p.conklerstable.transformban == 0
	and(p.cmd.buttons & BT_USE)
	and not P_IsObjectOnGround(p.mo)
	and abs(p.mo.momz)
	p.mo.momz = $-FixedMul(P_GetMobjGravity(p.mo), FRACUNIT/2) -- current momz = gravity / 2
	p.mo.state = S_PLAY_GLIDE
	end
	end
end)

addHook("AbilitySpecial", function(p)
if srb2p return end
	local meme = p.realmo
	if meme.skin != CONK_SKIN
		return 
	end
	if not (p.conklerstable.form & FORM_CLOUD)
	return 
	end
	if p.conklerstable.transformban == 1
	return 
	end
	if p.pflags&PF_THOKKED
		return true
	end
	P_SetObjectMomZ(p.mo, 14*FRACUNIT) 
	S_StartSound(p.mo, sfx_thok)
	p.pflags = $|PF_THOKKED 
	return true
end)

addHook("PlayerThink", function(p)
if srb2p return end
	local me = p.realmo
		if me.skin == CONK_SKIN
		and p.conklerstable.form & FORM_CLOUD
		and p.conklerstable.transformban == 0
		p.conklerstable.transform = 1
		p.mo.color = SKINCOLOR_WHITE
		A_Sparkling(p.mo,MT_SPINDUST)
	end
end)

addHook("PlayerThink", function(p)
if srb2p return end
	local me = p.realmo
		if me.skin == CONK_SKIN
		and not (p.conklerstable.form & FORM_CLOUD)
		and (p.powers[pw_carry] & CR_FAN or p.powers[pw_carry] & CR_DUSTDEVIL)
		and p.conklerstable.transformban == 0
		p.conklerstable.form = FORM_CLOUD
	end
end)